Index: palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3069)
+++ palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3083)
@@ -4001,13 +4389,13 @@
 !
 !--    Calculate the tendency term
-       tend(k,j,i) = tend(k,j,i)                                               &
-                                    + (                                        &
+       tend(k,j,i) = tend(k,j,i) + (                                           &
+                                      (                                        &
                       ( km(k,j,i)+km(k,j,i+1) ) * ( e(k,j,i+1)-e(k,j,i) )      &
                     - ( km(k,j,i)+km(k,j,i-1) ) * ( e(k,j,i)-e(k,j,i-1) )      &
-                                      ) * ddx2  * flag / sig_e                 &
+                                      ) * ddx2                                 &
                                     + (                                        &
                       ( km(k,j,i)+km(k,j+1,i) ) * ( e(k,j+1,i)-e(k,j,i) )      &
                     - ( km(k,j,i)+km(k,j-1,i) ) * ( e(k,j,i)-e(k,j-1,i) )      &
-                                      ) * ddy2  * flag / sig_e                 &
+                                      ) * ddy2                                 &
                                     + (                                        &
            ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1)     &
@@ -4015,6 +4403,7 @@
          - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)       &
                                                          * rho_air_zw(k-1)     &
-                                      ) * ddzw(k) * drho_air(k) * flag / sig_e &
-                                    - dissipation(k) * flag
+                                      ) * ddzw(k) * drho_air(k)                &
+                                   ) * flag * dsig_e                           &
+                                 - dissipation(k) * flag
 
     ENDDO
@@ -4082,13 +4471,13 @@
              flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
 
-             tend(k,j,i) = tend(k,j,i)                                         &
-                               + (                                             &
+             tend(k,j,i) = tend(k,j,i) +                                       &
+                         (       (                                             &
                  ( km(k,j,i)+km(k,j,i+1) ) * ( diss(k,j,i+1)-diss(k,j,i) )     &
                - ( km(k,j,i)+km(k,j,i-1) ) * ( diss(k,j,i)-diss(k,j,i-1) )     &
-                                 ) * ddx2  * flag                              &
+                                 ) * ddx2                                      &
                                + (                                             &
                  ( km(k,j,i)+km(k,j+1,i) ) * ( diss(k,j+1,i)-diss(k,j,i) )     &
                - ( km(k,j,i)+km(k,j-1,i) ) * ( diss(k,j,i)-diss(k,j-1,i) )     &
-                                 ) * ddy2  * flag                              &
+                                 ) * ddy2                                      &
                                + (                                             &
       ( km(k,j,i)+km(k+1,j,i) ) * ( diss(k+1,j,i)-diss(k,j,i) ) * ddzu(k+1)    &
@@ -4096,7 +4485,8 @@
     - ( km(k,j,i)+km(k-1,j,i) ) * ( diss(k,j,i)-diss(k-1,j,i) ) * ddzu(k)      &
                                                     * rho_air_zw(k-1)          &
-                                 ) * ddzw(k) * drho_air(k) * flag              &
-                               - c_2 * diss(k,j,i)**2                          &
-                                     / ( e(k,j,i) + 1.0E-20_wp ) * flag
+                                 ) * ddzw(k) * drho_air(k)                     &
+                         ) * flag * dsig_diss                                  &
+                         - c_2 * diss(k,j,i)**2                                &
+                               / ( e(k,j,i) + 1.0E-20_wp ) * flag
 
           ENDDO
@@ -4123,11 +4513,9 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i              !< running index x direction
-    INTEGER(iwp) ::  j              !< running index y direction
-    INTEGER(iwp) ::  k              !< running index z direction
-
-    REAL(wp)     ::  flag           !< flag to mask topography
-
-    REAL(wp), DIMENSION(nzb+1:nzt) :: tend_temp
+    INTEGER(iwp) ::  i         !< running index x direction
+    INTEGER(iwp) ::  j         !< running index y direction
+    INTEGER(iwp) ::  k         !< running index z direction
+
+    REAL(wp)     ::  flag      !< flag to mask topography
 
 !
@@ -4141,12 +4529,13 @@
 !
 !--    Calculate the tendency term
-       tend_temp(k) =           (                                              &
+       tend(k,j,i) =  tend(k,j,i) +                                            &
+                   (            (                                              &
                 ( km(k,j,i)+km(k,j,i+1) ) * ( diss(k,j,i+1)-diss(k,j,i) )      &
               - ( km(k,j,i)+km(k,j,i-1) ) * ( diss(k,j,i)-diss(k,j,i-1) )      &
-                                ) * ddx2  * flag / sig_diss                    &
+                                ) * ddx2                                       &
                               + (                                              &
                 ( km(k,j,i)+km(k,j+1,i) ) * ( diss(k,j+1,i)-diss(k,j,i) )      &
               - ( km(k,j,i)+km(k,j-1,i) ) * ( diss(k,j,i)-diss(k,j-1,i) )      &
-                                ) * ddy2  * flag / sig_diss                    &
+                                ) * ddy2                                       &
                               + (                                              &
      ( km(k,j,i)+km(k+1,j,i) ) * ( diss(k+1,j,i)-diss(k,j,i) ) * ddzu(k+1)     &
@@ -4154,9 +4543,7 @@
    - ( km(k,j,i)+km(k-1,j,i) ) * ( diss(k,j,i)-diss(k-1,j,i) ) * ddzu(k)       &
                                                    * rho_air_zw(k-1)           &
-                                ) * ddzw(k) * drho_air(k) * flag / sig_diss    &
-                              - c_2 * diss(k,j,i)**2                           &
-                                    / ( e(k,j,i) + 1.0E-20_wp ) * flag
-
-       tend(k,j,i) = tend(k,j,i) + tend_temp(k)
+                                ) * ddzw(k) * drho_air(k)                      &
+                   ) * flag * dsig_diss                                        &
+                   - c_2 * diss(k,j,i)**2 / ( e(k,j,i) + 1.0E-20_wp ) * flag
 
     ENDDO
@@ -4290,4 +4677,5 @@
 !> Computation of the turbulent diffusion coefficients for momentum and heat 
 !> according to Prandtl-Kolmogorov.
+!> @todo consider non-default surfaces
 !------------------------------------------------------------------------------!
  SUBROUTINE tcm_diffusivities( var, var_reference )
@@ -4297,30 +4685,33 @@
         ONLY:  e_min, outflow_l, outflow_n, outflow_r, outflow_s
 
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
     USE statistics,                                                            &
         ONLY :  rmask, sums_l_l
 
     USE surface_mod,                                                           &
-        ONLY :  bc_h, surf_def_h
+        ONLY :  bc_h, surf_def_h, surf_def_v
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i                   !<
-    INTEGER(iwp) ::  j                   !<
-    INTEGER(iwp) ::  k                   !<
-    INTEGER(iwp) ::  m                   !<
-    INTEGER(iwp) ::  n                   !<
-    INTEGER(iwp) ::  omp_get_thread_num  !<
-    INTEGER(iwp) ::  sr                  !<
-    INTEGER(iwp) ::  tn                  !<
-
-    REAL(wp)     ::  flag                !<
-    REAL(wp)     ::  l                   !<
-    REAL(wp)     ::  ll                  !<
-    REAL(wp)     ::  var_reference       !<
+    INTEGER(iwp) ::  i                   !< loop index
+    INTEGER(iwp) ::  j                   !< loop index
+    INTEGER(iwp) ::  k                   !< loop index
+    INTEGER(iwp) ::  m                   !< loop index
+    INTEGER(iwp) ::  n                   !< loop index
+    INTEGER(iwp) ::  omp_get_thread_num  !< opemmp function to get thread number
+    INTEGER(iwp) ::  sr                  !< statistic region
+    INTEGER(iwp) ::  tn                  !< thread number
+
+    REAL(wp)     ::  flag                !< topography flag
+    REAL(wp)     ::  l                   !< mixing length
+    REAL(wp)     ::  ll                  !< adjusted mixing length
+    REAL(wp)     ::  var_reference       !< reference temperature
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  var  !< 
+    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  var  !< temperature
 #else
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  var  !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  var  !< temperature
 #endif
 
@@ -4365,5 +4756,5 @@
 !
 !--             Compute diffusion coefficients for momentum and heat
-                km(k,j,i) = c_m * l * SQRT( e(k,j,i) ) * flag
+                km(k,j,i) = c_0 * l * SQRT( e(k,j,i) ) * flag
                 kh(k,j,i) = ( 1.0_wp + 2.0_wp * l / ll ) * km(k,j,i) * flag
 !
@@ -4391,5 +4782,5 @@
 !
 !--             Compute diffusion coefficients for momentum and heat
-                km(k,j,i) = c_m * l * SQRT( e(k,j,i) ) * flag
+                km(k,j,i) = c_0 * l * SQRT( e(k,j,i) ) * flag
                 kh(k,j,i) = km(k,j,i) / prandtl_number * flag
 !
@@ -4414,6 +4805,13 @@
 !
 !--             Compute diffusion coefficients for momentum and heat
-                km(k,j,i) = c_mu * e(k,j,i)**2 / ( diss(k,j,i) + 1.E-10 ) * flag
+                km(k,j,i) = c_0**4 * e(k,j,i)**2 / ( diss(k,j,i) + 1.0E-30_wp ) * flag
                 kh(k,j,i) = km(k,j,i) / prandtl_number * flag
+!
+!--             Summation for averaged profile of mixing length (cf. flow_statistics)
+                DO  sr = 0, statistic_regions
+                   sums_l_l(k,sr,tn) = sums_l_l(k,sr,tn) +                     &
+                      c_0**3 * e(k,j,i) * SQRT(e(k,j,i)) /                     &
+                      ( diss(k,j,i) + 1.0E-30_wp ) * rmask(j,i,sr) * flag
+                ENDDO
 
              ENDDO
@@ -4434,5 +4832,4 @@
 !-- so far vertical surfaces require usage of a Prandtl-layer where the boundary
 !-- values of the diffusivities are not needed.
-
     IF ( .NOT. rans_tke_e )  THEN
 !
@@ -4468,4 +4865,26 @@
           ENDDO
        ENDDO
+!
+!--    North- and southward facing surfaces
+       DO  n = 0, 1
+          DO  m = 1, surf_def_v(n)%ns
+             i = surf_def_v(n)%i(m)
+             j = surf_def_v(n)%j(m)
+             k = surf_def_v(n)%k(m)
+             km(k,j,i) = kappa * surf_def_v(n)%us(m) * 0.5_wp * dy
+             kh(k,j,i) = 1.35_wp * km(k,j,i)
+          ENDDO
+       ENDDO
+!
+!--    West- and eastward facing surfaces
+       DO  n = 2, 3
+          DO  m = 1, surf_def_v(n)%ns
+             i = surf_def_v(n)%i(m)
+             j = surf_def_v(n)%j(m)
+             k = surf_def_v(n)%k(m)
+             km(k,j,i) = kappa * surf_def_v(n)%us(m) * 0.5_wp * dx
+             kh(k,j,i) = 1.35_wp * km(k,j,i)
+          ENDDO
+       ENDDO
 
        CALL exchange_horiz( km, nbgp )
@@ -4473,4 +4892,5 @@
 
     ENDIF
+
 !
 !-- Model top
@@ -4518,5 +4938,5 @@
     INTEGER(iwp) ::  j      !< loop index y direction
     INTEGER(iwp) ::  k      !< loop index z direction
-    INTEGER, INTENT(IN) ::  mod_count  !<
+    INTEGER, INTENT(IN) ::  mod_count  !< flag defining where pointers point to
 
 #if defined( __nopointer )
Index: palm/trunk/SOURCE/vertical_nesting_mod.f90
===================================================================
--- palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 3069)
+++ palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 3083)
@@ -4058,4 +4058,9 @@
 !-- Identical timestep for coarse and fine grids
           dt_3d = MIN( dtc, dtf )
+          !> @fixme setting old_dt might be obsolete at this point
+          !>   Due to changes in timestep routine, setting of old_dt might be
+          !>   not necessary any more at this point. However, could not be
+          !>   tested so far.
+          !>   2018-05-18, gronemeier
           old_dt = dt_3d
 #endif
